<!-- Detail.vue -->

<template>
    <div>
        <div class="modal fade" ref="exampleModal" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title">Detalle</h5>
                        <button type="button" class="btn-close" @click="closeModal"></button>
                    </div>
                    <div class="modal-body">
                        <div class="mb-3">
                            <div class="mb-3">
                                <label for="validationValidInput1">Título</label>
                                <input type="text" class="form-control is-valid"
                                       v-model="title"
                                       id="validationValidInput1"
                                       readonly
                                       placeholder="Placeholder">
                            </div>
                            <div class="mb-3">
                                <label for="validationValidInput1">Autor</label>
                                <input type="text" class="form-control is-valid"
                                       readonly
                                       v-model="author"
                                       placeholder="Placeholder">
                            </div>
                            <div class="mb-3">
                                <label for="validationValidInput1">Fecha publicación</label>
                                <input type="date" class="form-control is-valid"
                                       readonly
                                       v-model="publication_date"
                                       placeholder="Placeholder">
                            </div>
                            <div class="mb-3">
                                <label for="validationInvalidTextarea1">Contenido</label>
                                <textarea class="form-control" placeholder="Textarea field"
                                          readonly
                                          v-model="content"
                                          id="validationInvalidTextarea1" rows="4"
                                          required></textarea>
                            </div>
                        </div>
                        <router-link to="/"></router-link>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" @click="closeModal">Close</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>

export default {
    data() {
        return {
            item: {},
            title: '',
            author: '',
            publication_date: '',
            content: '',
        };
    },
    mounted() {
        this.modalInstance = new bootstrap.Modal(this.$refs.exampleModal, { backdrop: 'static', keyboard: false });
        this.modalInstance.show();
        const postId = this.$route.params.id;
        if (postId !== this.item.id) {
            this.axiosDetail(postId);
        }
    },
    methods: {
         async axiosDetail(id) {
          try {
          const response = await axios.get(`api/v1/posts/${id}`);
           if (response && response.data) {
              this.item = response.data.data;
              this.title = this.item.title;
               this.author = this.item.author
               this.publication_date = this.item.publication_date
               this.content = this.item.content
           }
          } catch (error) {
              swal.fire({
                  icon: 'error',
                  title: 'Error',
                  text: 'Error al procesar la solicitud.',
              });
          }
         },
        closeModal() {
            this.modalInstance.hide();
            this.$router.replace({ path: '/' }).catch(() => {});
        }
    },
};
</script>
